---
title: 'Document: keyup event'
slug: Web/API/Document/keyup_event
tags:
  - DOM
  - Document
  - Event
  - KeyboardEvent
  - Reference
  - keyup
---
<div>{{APIRef}}</div>

<p>The <strong><code>keyup</code></strong> event is fired when a key is released.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("KeyboardEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("GlobalEventHandlers.onkeyup", "onkeyup")}}</td>
  </tr>
 </tbody>
</table>

<p>The {{domxref("Document/keydown_event", "keydown")}} and <code>keyup</code> events provide a code indicating which key is pressed, while {{domxref("Document/keypress_event", "keypress")}} indicates which <em>character</em> was entered. For example, a lowercase "a" will be reported as 65 by <code>keydown</code> and <code>keyup</code>, but as 97 by <code>keypress</code>. An uppercase "A" is reported as 65 by all events.</p>

<div class="notecard note">
<p><strong>Note:</strong> If you're looking for a way to react to changes in an input's value, you should use the <a href="/en-US/docs/Web/API/HTMLElement/input_event"><code>input</code> event</a>. Some changes are not detectable by <code>keyup</code>, for example pasting text from the context menu in a text input.</p>
</div>

<p>Since Firefox 65, the {{domxref("Document/keydown_event", "keydown")}} and <code>keyup</code> events are now fired during IME composition, to improve cross-browser compatibility for CJKT users ({{bug(354358)}}, also see <a href="https://www.fxsitecompat.com/en-CA/docs/2018/keydown-and-keyup-events-are-now-fired-during-ime-composition/">keydown and keyup events are now fired during IME composition</a> for more useful details). To ignore all <code>keyup</code> events that are part of composition, do something like this (229 is a special value set for a <code>keyCode</code> relating to an event that has been processed by an IME):</p>

<pre class="brush: js">eventTarget.addEventListener("keyup", event =&gt; {
  if (event.isComposing || event.keyCode === 229) {
    return;
  }
  // do something
});
</pre>

<h2 id="Examples">Examples</h2>

<p>This example logs the {{domxref("KeyboardEvent.code")}} value whenever you release a key.</p>

<h3 id="addEventListener_keyup_example">addEventListener keyup example</h3>

<pre class="brush: html">&lt;p&gt;Focus the IFrame first (e.g. by clicking in it), then try pressing some keys.&lt;/p&gt;
&lt;p id="log"&gt;&lt;/p&gt;</pre>

<pre class="brush: js">const log = document.getElementById('log');

document.addEventListener('keyup', logKey);

function logKey(e) {
  log.textContent += ` ${e.code}`;
}</pre>

<p>{{EmbedLiveSample("addEventListener_keyup_example")}}</p>

<h3 id="onkeyup_equivalent">onkeyup equivalent</h3>

<pre class="brush: js">document.onkeyup = logKey;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("UI Events", "#event-type-keyup")}}</td>
   <td>{{Spec2("UI Events")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.keyup_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Document/keydown_event", "keydown")}}</li>
 <li>{{domxref("Document/keypress_event", "keypress")}}</li>
 <li>{{domxref("Element")}}: {{domxref("Element/keyup_event", "keyup")}} event</li>
</ul>
